"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var propertyNames_1 = require("./propertyNames");
function reduced(result) {
    var _a;
    return _a = {},
        _a[propertyNames_1.REDUCED] = true,
        _a[propertyNames_1.VALUE] = result,
        _a;
}
exports.reduced = reduced;
function isReduced(result) {
    return result && result[propertyNames_1.REDUCED] === true;
}
exports.isReduced = isReduced;
function ensureReduced(result) {
    return isReduced(result) ? result : reduced(result);
}
exports.ensureReduced = ensureReduced;
function unreduced(result) {
    return isReduced(result) ? result[propertyNames_1.VALUE] : result;
}
exports.unreduced = unreduced;
function compose() {
    var fs = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        fs[_i] = arguments[_i];
    }
    return function (x) {
        var result = x;
        for (var i = fs.length - 1; i >= 0; i--) {
            result = fs[i](result);
        }
        return result;
    };
}
exports.compose = compose;
//# sourceMappingURL=util.js.map