import { CompletingTransformer, Dictionary, Transformer } from "./types";
export declare function count(): Transformer<number, any>;
export declare function every<T>(pred: (item: T) => boolean): Transformer<boolean, T>;
export declare function find<T>(pred: (item: T) => boolean): Transformer<T | null, T>;
export declare function first<T>(): Transformer<T | null, T>;
export declare function forEach<T>(f: (input: T) => void): Transformer<void, T>;
export declare function isEmpty(): Transformer<boolean, any>;
export declare function joinToString(separator: string): CompletingTransformer<any[], string, any>;
export declare function some<T>(pred: (item: T) => boolean): Transformer<boolean, T>;
export declare function toArray<T>(): Transformer<T[], T>;
export declare function toMap<T, K, V>(getKey: (item: T) => K, getValue: (item: T) => V): Transformer<Map<K, V>, T>;
export declare function toMapGroupBy<T, K>(getKey: (item: T) => K): Transformer<Map<K, T[]>, T>;
export declare function toMapGroupBy<T, K, V>(getKey: (item: T) => K, transformer: CompletingTransformer<any, V, T>): Transformer<Map<K, V>, T>;
export declare function toObject<T, U>(getKey: (item: T) => string, getValue: (item: T) => U): Transformer<Dictionary<U>, T>;
export declare function toObjectGroupBy<T>(getKey: (item: T) => string): Transformer<Dictionary<T[]>, T>;
export declare function toObjectGroupBy<T, U>(getKey: (item: T) => string, transformer: CompletingTransformer<any, U, T>): Transformer<Dictionary<U>, T>;
export declare function toSet<T>(): Transformer<Set<T>, T>;
export declare function toAverage(): CompletingTransformer<[number, number], number | null, number>;
export declare function toMax(): Transformer<number | null, number>;
export declare function toMax<T>(comparator: (a: T, b: T) => number): Transformer<T | null, T>;
export declare function toMin(): Transformer<number | null, number>;
export declare function toMin<T>(comparator: (a: T, b: T) => number): Transformer<T | null, T>;
export declare function toSum(): Transformer<number, number>;
