import { Transducer } from "./types";
export declare function dedupe<T>(): Transducer<T, T>;
export declare function drop<T>(n: number): Transducer<T, T>;
export declare function dropWhile<T>(pred: (item: T) => boolean): Transducer<T, T>;
export declare function filter<T>(pred: (item: T) => boolean): Transducer<T, T>;
export declare function flatMap<T, U>(f: (item: T) => Iterable<U>): Transducer<T, U>;
export declare function interpose<T>(separator: T): Transducer<T, T>;
export declare function map<T, U>(f: (item: T) => U): Transducer<T, U>;
export declare function mapIndexed<T, U>(f: (item: T, index: number) => U): Transducer<T, U>;
export declare function partitionAll<T>(n: number): Transducer<T, T[]>;
export declare function partitionBy<T>(f: (item: T) => any): Transducer<T, T[]>;
export declare function remove<T>(pred: (item: T) => boolean): Transducer<T, T>;
export declare function take<T>(n: number): Transducer<T, T>;
export declare function takeNth<T>(n: number): Transducer<T, T>;
export declare function takeWhile<T>(pred: (item: T) => boolean): Transducer<T, T>;
