export interface Reduced<T> {
    ["@@transducer/reduced"]: boolean;
    ["@@transducer/value"]: T;
}
export declare type MaybeReduced<T> = T | Reduced<T>;
/**
 * Reducers are allowed to indicate that no further computation is needed by
 * returning a Reduced result.
 */
export declare type QuittingReducer<TResult, TInput> = (result: TResult, input: TInput) => MaybeReduced<TResult>;
export declare type Transducer<TInput, TOutput> = <TCompleteResult>(xf: CompletingTransformer<any, TCompleteResult, TOutput>) => CompletingTransformer<any, TCompleteResult, TInput>;
export interface CompletingTransformer<TResult, TCompleteResult, TInput> {
    ["@@transducer/init"](): TResult;
    ["@@transducer/step"](result: TResult, input: TInput): MaybeReduced<TResult>;
    ["@@transducer/result"](result: TResult): TCompleteResult;
}
export declare type Transformer<TResult, TInput> = CompletingTransformer<TResult, TResult, TInput>;
export declare type NonNullable<T> = T & {};
export declare type Comparator<T> = (a: T, b: T) => number;
export interface Dictionary<T> {
    [key: string]: T;
}
